=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2007-01-26 04:00:12 +0000
+++ bzrlib/branch.py	2007-01-26 04:18:44 +0000
@@ -629,12 +629,16 @@
         tree = checkout.create_workingtree(revision_id)
         for path, entry in tree.inventory.iter_entries_by_dir():
             if entry.kind == 'tree-reference':
-                path = id2abspath(entry.file_id)
-                reference_parent = self.reference_parent(entry.file_id)
-                reference_parent.create_checkout(path, entry.reference_revision,
+                path = tree.id2path(entry.file_id)
+                reference_parent = self.reference_parent(entry.file_id, path)
+                reference_parent.create_checkout(tree.abspath(path),
+                                                 entry.reference_revision,
                                                  lightweight)
         return tree
 
+    def reference_parent(self, file_id, path):
+        return Branch.open(self.bzrdir.root_transport.clone(path).base)
+
 
 class BranchFormat(object):
     """An encapsulation of the initialization and open routines for a format.

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2007-01-15 13:10:20 +0000
+++ bzrlib/tests/test_branch.py	2007-01-26 04:18:44 +0000
@@ -153,6 +153,7 @@
         subtree.add('file')
         tree.add_reference(subtree)
         tree.commit('a revision')
+        subtree.commit('a subtree file')
         tree.branch.create_checkout('target')
         self.failUnlessExists('target')
         self.failUnlessExists('target/subtree')

